(* Copyright (C) 1989, 1990 Digital Equipment Corporation	*)
(* All rights reserved.						*)
(* See the file COPYRIGHT for a full description.		*)

(* File: XtN.i3							*)
(* Last modified on Fri Apr 13 14:10:01 1990 by jerome		*)
(*      modified on Sat Feb 24 02:19:12 1990 by muller		*)


INTERFACE XtN;

(*==============================================================*)
(*	The X11 R4 Interface for Modula 3			*)
(*								*)
(*	Resource names corresponding to:			*)
(*			X11 R4 Intrinsic			*)
(*			X11 R4 Athena Widget Set		*)
(*==============================================================*)


FROM Ctypes IMPORT CharStar;

VAR
  accelerators                   : CharStar;
  allowHoriz                     : CharStar;
  allowResize                    : CharStar;
  allowShellResize               : CharStar;
  allowVert                      : CharStar;
  analog                         : CharStar;
  ancestorSensitive              : CharStar;
  argc                           : CharStar;
  argv                           : CharStar;
  autoFill                       : CharStar;
  background                     : CharStar;
  backgroundPixmap               : CharStar;
  backingStore                   : CharStar;
  baseHeight                     : CharStar;
  baseWidth                      : CharStar;
  betweenCursor                  : CharStar;
  bitmap                         : CharStar;
  border                         : CharStar;
  borderColor                    : CharStar;
  borderPixmap                   : CharStar;
  borderWidth                    : CharStar;
  bottom                         : CharStar;
  bottomMargin                   : CharStar;
  callback                       : CharStar;
  checkCommand                   : CharStar;
  children                       : CharStar;
  chime                          : CharStar;
  colormap                       : CharStar;
  columnSpacing                  : CharStar;
  columnWidth                    : CharStar;
  cornerRoundPercent             : CharStar;
  createPopupChildProc           : CharStar;
  cursor                         : CharStar;
  dataCompression                : CharStar;
  defaultColumns                 : CharStar;
  defaultDistance                : CharStar;
  depth                          : CharStar;
  destroyCallback                : CharStar;
  dialogHOffset                  : CharStar;
  dialogVOffset                  : CharStar;
  displayCaret                   : CharStar;
  displayNonprinting             : CharStar;
  displayPosition                : CharStar;
  echo                           : CharStar;
  editType                       : CharStar;
  emptyPixmap                    : CharStar;
  emptyPixmapMask                : CharStar;
  file                           : CharStar;
  flip                           : CharStar;
  font                           : CharStar;
  forceBars                      : CharStar;
  forceColumns                   : CharStar;
  foreground                     : CharStar;
  fromHoriz                      : CharStar;
  fromVert                       : CharStar;
  fullPixmap                     : CharStar;
  fullPixmapMask                 : CharStar;
  function                       : CharStar;
  geometry                       : CharStar;
  getValue                       : CharStar;
  gripCursor                     : CharStar;
  gripIndent                     : CharStar;
  gripTranslations               : CharStar;
  hSpace                         : CharStar;
  hand                           : CharStar;
  height                         : CharStar;
  heightInc                      : CharStar;
  highlight                      : CharStar;
  highlightThickness             : CharStar;
  horizDistance                  : CharStar;
  horizontalBetweenCursor        : CharStar;
  horizontalGripCursor           : CharStar;
  icon                           : CharStar;
  iconMask                       : CharStar;
  iconName                       : CharStar;
  iconNameEncoding               : CharStar;
  iconPixmap                     : CharStar;
  iconWindow                     : CharStar;
  iconX                          : CharStar;
  iconY                          : CharStar;
  iconic                         : CharStar;
  index                          : CharStar;
  initialResourcesPersistent     : CharStar;
  initialState                   : CharStar;
  innerHeight                    : CharStar;
  innerWidth                     : CharStar;
  innerWindow                    : CharStar;
  input                          : CharStar;
  insensitiveBorder              : CharStar;
  insertPosition                 : CharStar;
  internalBorderColor            : CharStar;
  internalBorderWidth            : CharStar;
  internalHeight                 : CharStar;
  internalWidth                  : CharStar;
  jumpProc                       : CharStar;
  jumpScroll                     : CharStar;
  justify                        : CharStar;
  knobHeight                     : CharStar;
  knobIndent                     : CharStar;
  knobPixel                      : CharStar;
  knobWidth                      : CharStar;
  label                          : CharStar;
  labelClass                     : CharStar;
  left                           : CharStar;
  leftBitmap                     : CharStar;
  leftCursor                     : CharStar;
  leftMargin                     : CharStar;
  length                         : CharStar;
  lineWidth                      : CharStar;
  list                           : CharStar;
  longest                        : CharStar;
  lowerCursor                    : CharStar;
  lowerRight                     : CharStar;
  mappedWhenManaged              : CharStar;
  max                            : CharStar;
  maxAspectX                     : CharStar;
  maxAspectY                     : CharStar;
  maxHeight                      : CharStar;
  maxWidth                       : CharStar;
  menuEntry                      : CharStar;
  menuName                       : CharStar;
  menuOnScreen                   : CharStar;
  min                            : CharStar;
  minAspectX                     : CharStar;
  minAspectY                     : CharStar;
  minHeight                      : CharStar;
  minScale                       : CharStar;
  minWidth                       : CharStar;
  minimumThumb                   : CharStar;
  name                           : CharStar;
  notify                         : CharStar;
  numChildren                    : CharStar;
  numberStrings                  : CharStar;
  onceOnly                       : CharStar;
  orientation                    : CharStar;
  overrideRedirect               : CharStar;
  padding                        : CharStar;
  parameter                      : CharStar;
  pasteBuffer                    : CharStar;
  pieceSize                      : CharStar;
  pixmap                         : CharStar;
  popdownCallback                : CharStar;
  popupCallback                  : CharStar;
  popupOnEntry                   : CharStar;
  position                       : CharStar;
  preferredPaneSize              : CharStar;
  radioData                      : CharStar;
  radioGroup                     : CharStar;
  refigureMode                   : CharStar;
  resizable                      : CharStar;
  resize                         : CharStar;
  resizeToPreferred              : CharStar;
  reverseVideo                   : CharStar;
  right                          : CharStar;
  rightBitmap                    : CharStar;
  rightCursor                    : CharStar;
  rightMargin                    : CharStar;
  rowHeight                      : CharStar;
  rowSpacing                     : CharStar;
  saveUnder                      : CharStar;
  scale                          : CharStar;
  screen                         : CharStar;
  scrollDCursor                  : CharStar;
  scrollHCursor                  : CharStar;
  scrollHorizontal               : CharStar;
  scrollLCursor                  : CharStar;
  scrollProc                     : CharStar;
  scrollRCursor                  : CharStar;
  scrollUCursor                  : CharStar;
  scrollVCursor                  : CharStar;
  scrollVertical                 : CharStar;
  selectTypes                    : CharStar;
  selection                      : CharStar;
  selectionArray                 : CharStar;
  sensitive                      : CharStar;
  shapeStyle                     : CharStar;
  shapeWindow                    : CharStar;
  showGrip                       : CharStar;
  shown                          : CharStar;
  skipAdjust                     : CharStar;
  space                          : CharStar;
  state                          : CharStar;
  stipple                        : CharStar;
  string                         : CharStar;
  templateResource               : CharStar;
  textOptions                    : CharStar;
  textSink                       : CharStar;
  textSource                     : CharStar;
  thickness                      : CharStar;
  thumb                          : CharStar;
  thumbProc                      : CharStar;
  title                          : CharStar;
  titleEncoding                  : CharStar;
  top                            : CharStar;
  topMargin                      : CharStar;
  topOfThumb                     : CharStar;
  transient                      : CharStar;
  transientFor                   : CharStar;
  translations                   : CharStar;
  type                           : CharStar;
  unrealizeCallback              : CharStar;
  update                         : CharStar;
  upperCursor                    : CharStar;
  useBottom                      : CharStar;
  useRight                       : CharStar;
  useStringInPlace               : CharStar;
  vSpace                         : CharStar;
  value                          : CharStar;
  vertDistance                   : CharStar;
  vertSpace                      : CharStar;
  verticalBetweenCursor          : CharStar;
  verticalGripCursor             : CharStar;
  verticalList                   : CharStar;
  visual                         : CharStar;
  vmunix                         : CharStar;
  volume                         : CharStar;
  waitForWm                      : CharStar;
  width                          : CharStar;
  widthInc                       : CharStar;
  winGravity                     : CharStar;
  window                         : CharStar;
  windowGroup                    : CharStar;
  wmTimeout                      : CharStar;
  wrap                           : CharStar;
  x                              : CharStar;
  y                              : CharStar;


PROCEDURE ForceToLoadAnImplementation ();

END XtN.
