# define ENDOFFILE 0
# define AMPERSAND 258
# define ASSIGN 259
# define ASTERISK 260
# define BAR 261
# define COLON 262
# define COMMA 263
# define DOT 264
# define DOTDOT 265
# define EQUAL 266
# define GREATER 267
# define GREQUAL 268
# define LESS 269
# define LSEQUAL 270
# define MINUS 271
# define SHARP 272
# define PERIOD 273
# define PLUS 274
# define RARROW 275
# define RBRACE 276
# define RBRACKET 277
# define RPAREN 278
# define SEMICOLON 279
# define SLASH 280
# define SUBTYPE 281
# define UPARROW 282
# define LPAREN 283
# define LBRACKET 284
# define LBRACE 285
# define IDENT 286
# define CARD_CONST 287
# define REAL_CONST 288
# define CHAR_CONST 289
# define STR_CONST 290
# define AND 291
# define ANY 292
# define ARRAY 293
# define AS 294
# define BGN 295
# define BITS 296
# define BRANDED 297
# define BY 298
# define CASE 299
# define CONST 300
# define DIV 301
# define DO 302
# define ELSE 303
# define ELSIF 304
# define END 305
# define EVAL 306
# define EXCEPT 307
# define EXCEPTION 308
# define EXIT 309
# define EXPORTS 310
# define FINALLY 311
# define FOR 312
# define FROM 313
# define GENERIC 314
# define IF 315
# define IMPORT 316
# define IN 317
# define INTERFACE 318
# define LOCK 319
# define LOOP 320
# define METHODS 321
# define MOD 322
# define MODULE 323
# define NOT 324
# define OBJECT 325
# define OF 326
# define OR 327
# define OVERRIDES 328
# define PROCEDURE 329
# define RAISE 330
# define RAISES 331
# define READONLY 332
# define RECORD 333
# define REF 334
# define REPEAT 335
# define RETURN 336
# define REVEAL 337
# define ROOT 338
# define SET 339
# define THEN 340
# define TO 341
# define TRY 342
# define TYPE 343
# define TYPECASE 344
# define UNSAFE 345
# define UNTIL 346
# define UNTRACED 347
# define VALUE 348
# define VAR 349
# define WHILE 350
# define WITH 351

# line 40 "../src/parse.yacc"
/* make yacc's stack larger than the default of 150 */
#define YYMAXDEPTH 300
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern short yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#ifndef YYSTYPE
#define YYSTYPE int
#endif
YYSTYPE yylval, yyval;
# define YYERRCODE 256

# line 665 "../src/parse.yacc"


#include <stdio.h>

extern notypes, novars, noconst, noexcepts, oldstyle, qnames;

int linecnt = 1;
int charcnt;
int charperlinecnt; /* charcnt for current line */
char linebuf[1000];  /* chars of current line */
char lastident[200];/* last identifier encountered */

int comdepth = 0;
  /* depth of comments, used only by lexer. */
int pragdepth = 0;
  /* depth of pragmas, used only by lexer. */

yyerror(s)
     char *s;
{
    fprintf(stderr, "line %d: %s\n", linecnt, s);
}

#include "hash.h"
#include "lex.yy.c"

#define MAXITEMS 8000   /* X.i3 has a lot of constants! */
int itemcnt, itemcharcnt;
char *items[MAXITEMS];

setinput(fp)
	FILE *fp;
{
  yyin = fp;
}

char qualifier[200];
recordQual(name)
{
	strcpy(qualifier, name);
}

recordname(name, qual)
   char *name;
{
  char buf[200];
  
  recordname1(name);
   if (qual && qnames) {
     strcpy(buf, qualifier);
     strcat(buf, ".");
     strcat(buf, name);
     recordname1(buf);
   }
}

recordname1(name)
	char *name;
{
  int ln;
  char buf[200];
  
  if (oldstyle) {
    sprintf(buf, "%s\177%d,%d\n", linebuf, linecnt, charcnt); }
  else {
    sprintf(buf, "%s\177%s\177%d,%d\n", name, linebuf, linecnt, charcnt); }
  ln = strlen(buf);
  if (itemcnt >= MAXITEMS) {
    fprintf(stderr, "help: too many items\n");
    exit(1); }
  items[itemcnt] = (char *)malloc(ln+1);
  if (items[itemcnt] == 0) {
    fprintf (stderr, "help: memory exhausted\n");
    exit (1); } 
  strcpy(items[itemcnt], buf);
  itemcnt++;
  itemcharcnt += ln;
}

printit(name)
     char *name;
{
  int i;

  printf("\014\n%s,%d\n", name, itemcharcnt);
  for (i = 0; i < itemcnt; i++) {
    printf("%s", items[i]); }
}

initialize()
{
  itemcnt = itemcharcnt = 0;
  linecnt = 1;
  charcnt = charperlinecnt = 0;
}
short yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
-1, 12,
	279, 7,
	-2, 9,
-1, 13,
	266, 13,
	-2, 11,
-1, 75,
	266, 51,
	-2, 49,
-1, 78,
	281, 57,
	-2, 55,
-1, 97,
	305, 98,
	-2, 33,
-1, 152,
	305, 98,
	-2, 33,
-1, 154,
	346, 98,
	-2, 33,
-1, 156,
	307, 98,
	311, 98,
	-2, 33,
-1, 197,
	325, 209,
	-2, 179,
-1, 198,
	325, 209,
	-2, 195,
-1, 207,
	325, 209,
	-2, 190,
-1, 217,
	286, 88,
	-2, 80,
-1, 221,
	303, 100,
	304, 100,
	305, 100,
	307, 100,
	311, 100,
	346, 100,
	-2, 33,
-1, 223,
	305, 98,
	-2, 33,
-1, 280,
	325, 209,
	-2, 180,
-1, 282,
	325, 209,
	-2, 181,
-1, 284,
	325, 209,
	-2, 189,
-1, 299,
	286, 88,
	-2, 82,
-1, 312,
	303, 98,
	304, 98,
	305, 98,
	-2, 33,
-1, 313,
	305, 98,
	-2, 33,
-1, 316,
	305, 98,
	-2, 33,
-1, 318,
	325, 209,
	334, 209,
	-2, 162,
-1, 319,
	305, 98,
	-2, 33,
-1, 320,
	305, 98,
	-2, 33,
-1, 418,
	305, 98,
	-2, 33,
-1, 419,
	261, 101,
	303, 101,
	305, 101,
	-2, 33,
-1, 430,
	261, 101,
	303, 101,
	305, 101,
	-2, 33,
-1, 435,
	261, 101,
	303, 101,
	305, 101,
	-2, 33,
-1, 509,
	261, 104,
	303, 104,
	305, 104,
	-2, 33,
-1, 527,
	305, 98,
	-2, 33,
-1, 529,
	303, 98,
	304, 98,
	305, 98,
	-2, 33,
-1, 530,
	261, 101,
	303, 101,
	305, 101,
	-2, 33,
-1, 531,
	261, 101,
	303, 101,
	305, 101,
	-2, 33,
	};
# define YYNPROD 309
# define YYLAST 770
short yyact[]={

 144, 467, 377, 125,  79, 501, 498, 123, 216, 124,
 458, 455, 398, 203, 198, 380, 391, 368, 379, 366,
 375, 376, 174, 342, 365, 173, 265, 341, 315, 304,
 422, 529, 312, 212, 181, 461, 416, 176, 177, 178,
 179, 180, 291, 223, 183, 302, 303, 453,  53,   9,
 146, 353, 291,   7, 335, 239,  57, 148,   8, 318,
 147, 290, 291, 149, 310, 182, 150, 271,  14, 255,
 151, 152, 237,  15, 286, 164, 409,  58,   7,  40,
   3, 153,  41,   8, 184,  55, 154, 155,  91, 256,
 185,  54, 354, 156, 317, 157,  25,  56, 316,  53,
 542, 158, 159, 516, 187, 514, 512,  57, 174, 508,
 257, 173, 496, 483, 213, 390, 477, 336, 418, 475,
 181, 210, 209, 394, 177, 178, 179, 180,  58, 464,
 183, 258, 438, 205, 212, 437,  55, 425, 424, 196,
 364, 338,  54, 314, 215, 220,  98, 224,  56, 225,
  62, 227, 228, 527, 230, 319, 232, 313, 234, 235,
 229, 164, 231, 269, 233, 434, 206, 428,  97, 511,
 184, 417, 301,  53, 298, 202, 185, 212, 204, 321,
 219,  57, 262, 204, 201,  94, 240, 266, 294,  32,
 208,  80, 275, 243, 247, 248, 245, 246, 506, 244,
  48, 500,  58, 457, 486, 507, 287, 418, 479, 418,
  55, 293, 386, 418, 238, 288,  54, 274, 320, 276,
 277, 174,  56, 308, 173, 307,  33, 283, 306, 305,
 273, 309, 226, 181, 210, 209, 394, 177, 178, 179,
 180, 214, 195, 183, 249, 194, 205, 212, 186, 204,
 200, 210, 209,  80, 121, 119, 204, 120, 204, 204,
 183,  89,  85, 205, 212,  75, 204,  95,  90,  70,
  53,  65,  61,  59, 164,  50,  45,  30,  57, 206,
 351,  21,  20, 184,  13,  12, 217,  36, 202, 185,
 335, 337, 193, 264, 505, 211, 206, 201, 345,  58,
 184, 541, 435, 540, 534, 202, 185,  55, 518, 115,
 436, 369, 370,  54, 201, 523, 373, 355, 217,  56,
 371, 372, 378, 385, 374, 116,  44, 382, 383, 117,
 204, 329, 388, 392, 399, 522, 509, 204, 449,  93,
 279, 431, 218, 451, 450, 403, 393, 395, 404, 330,
 332, 331, 333, 430,  71,  92, 204, 442, 448, 410,
 278, 429, 400, 401, 405, 359, 350,  72, 349, 348,
 402, 295, 441,  48, 221, 189,  49,  46,  31,  22,
 406, 407, 517, 515, 204, 415, 440, 414, 281, 281,
 360, 413, 285, 352, 384, 432, 334, 426, 281, 296,
 439, 204, 204,  68, 459, 535, 490, 357, 531, 204,
 530, 270, 420, 427, 253, 267, 347, 433, 369, 204,
 204, 369, 471, 472, 419, 447, 466, 252, 322, 469,
 251, 446, 480, 378, 192, 191, 481, 485, 470, 462,
 469, 487, 465, 392, 489, 469, 399, 493, 494, 478,
 495,  34, 463, 484,  23, 421, 393, 395, 491, 488,
 473, 358, 346, 476, 363, 272, 504, 503, 502, 482,
 188, 281, 362, 281, 361, 281, 513, 344, 204, 356,
 343,  44, 113, 122, 109, 112, 111, 431, 200, 210,
 209,  80, 101,  96, 445,  44, 412, 190, 183, 521,
 204, 205, 212, 289, 443, 520, 519, 311, 222, 526,
 524, 378, 528, 307, 171, 169, 167, 163,  47, 207,
 161, 381,  87,  77,  74,  83, 532,  63, 533,  24,
 444, 396, 538, 539, 206, 536, 492, 537, 184, 389,
 469, 469, 174, 202, 185, 173,  76, 145, 387,  26,
 174, 197, 201, 173, 181, 397, 328, 176, 177, 178,
 179, 180, 181, 261, 183, 176, 177, 178, 179, 180,
 174,   4, 183, 173, 175,  11, 289,  38, 289,  29,
 289, 172, 181, 254, 170, 176, 177, 178, 179, 180,
   2,  64, 183, 250,  10, 164, 168, 100, 103, 102,
 106, 242,  81, 164, 184, 106,  78,  78, 110, 114,
 185,  43, 184, 166, 165,  99,  35,  64, 185,  64,
 162, 160, 499, 164, 174, 456,  67, 173,  78,  69,
 268, 497, 184,  78, 454, 452, 181, 408, 185, 176,
 177, 178, 179, 180, 199,  37, 183,  42, 236, 474,
 423, 510, 367, 143, 142, 141, 140, 139, 138, 137,
 136, 135,  66, 134, 133, 132, 131, 130, 129, 128,
 126, 468, 300, 299, 525, 460, 411, 297, 118,  88,
 340,  84, 241, 108, 339, 107, 184, 105, 259, 260,
 104,  86, 185,  82,  73,  52,  51, 127,  60,  39,
  28,  27,  19,  18,  17, 263,  16,   6,   5,   1,
   0,   0,   0,   0,   0,   0,   0, 280, 282,   0,
   0, 284,   0,   0,   0,   0,   0,   0, 292,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0, 324, 325,
 323,   0,   0,   0,   0,   0, 326,   0,   0, 327 };
short yypact[]={

-265,-1000,-1000,-240,-1000,-1000,-1000,  -1,  -2,-250,
-1000,-1000,-1000,-1000,  -4,  -5, 100, 188,-214,-214,
-1000,-1000,-1000,  -9,  99, -60, 185,   4,   4,-234,
   4,-1000, 232,-1000, -10,  98, -60,  97, -30,-1000,
 -13, -14,-155,-234, -15,   4,-1000, 125, 232,-1000,
 -17,-1000,  88, -21, -95, -95, -24, -25, -18,-228,
  76,-109, -19, 229,-127,-1000,-159,-234,-1000,-234,
 228,-1000,-1000, -21,-1000,-1000, -95,-1000,-1000,-1000,
 220, -95, -24,-1000, 223,-1000, -25,-1000,  46,-1000,
-1000, -60,-1000, -29, -32, 219,-1000,-249, -38,-201,
 206,-1000,  96,-1000, 235, 169,-1000, 168,  11, -41,
-1000, -44, 205, 299,-1000, -45,-1000, 205,   3,  63,
-114,-1000,-1000,-160,  95,-1000,-1000,-1000,-1000,-1000,
-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000,
-1000,-1000,-1000,-1000, 249,-252, 299,-1000, 299, -54,
 299, 299,-249, 299,-249, 299,-249, 299, 299, -72,
-272,-1000,-105,-1000, 299,-1000, -73,-1000, 156,-1000,
-191,-1000,-1000, 353, 353,-1000,-1000,-1000,-1000,-1000,
-1000, 299,-1000, -33, -60,-259, 201, -56,-1000,-1000,
 205, 299, 205, 205,-1000,-1000,  81,-120,-120,-1000,
 205,-264,-1000,-1000,-1000, 299,   3,-120,-273, -60,
 299,-1000,-102,  92,-1000, 121,-1000,-303,-1000, -57,
 -58,-249, 299,-249,-262,-1000, 248,-308,-145,-162,
-1000,-318,-1000,-213,-267,-147, -84,-1000, 162, 299,
 299,-1000, 353,-1000,-1000,-1000,-1000,-1000,-1000,-1000,
 353,-1000,-1000,-1000, 353,-1000,-1000,-1000,-1000,-1000,
-1000,  67, 118,-209, 205,-1000,-164,-1000, -60, 218,
-1000, 205,-1000, 198, 150,  90,  89,  87,-1000, 299,
-120,-263,-120, 115,-120,-283,-1000,-220,-1000,-1000,
 205, -60, 131, 196,-1000,-1000,  86, 112,-1000,-303,
 -60,-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000,-165,
 299, 299,-249,-249,-1000, 299,-249, -95, 205,-249,
-249, -72, 299,-1000,-1000,-1000,-1000,-1000,-1000, -74,
-1000, 299,-163, 279,-1000, 205, 205,-1000,-1000,-1000,
-1000,-1000,-1000, 205, 299,-1000,-1000, 299,-1000,-1000,
-1000,  85,-1000, 205, 205,-1000,-245,-1000, 299,-1000,
 234,-1000,-1000, 218,-1000,-1000, -90, 149,-1000, 190,
-311,-1000,-167,-1000,-168,-1000, -94,  78,-1000,-1000,
 -96,  27,-170,-173,-1000,-1000,-1000, 123,-1000,  94,
-1000,-1000,-1000,-1000, 245,-1000, 231,-1000,-1000, 166,
-1000,-1000,  79,  65,  64,-1000,-1000,-1000,-281, -83,
 127,-296, 205,-1000,-1000, -90,-176, 299,-249,-249,
 299, 299, 299,-185,-1000,-1000, -94,-189, -95, -78,
-249, -95, -96,-192, 205,-249, -82,-1000,-1000,-1000,
 299,-1000, -50, 299, 130, 271, 299, 299,-1000, 299,
-1000,-1000,-193, -85,-1000,-1000, -83,  35,-1000,-1000,
-1000, -87,-1000,-196,-1000,-1000,-1000,-1000,-1000,  57,
-1000,-1000,-129,-199,-1000, 299,-200,-1000,-1000, 105,
-1000,-1000,-202,-1000,-1000,-1000, 104,-1000,-1000,-1000,
-1000,-1000,-1000,-1000,-1000,  29,-1000,-1000,-1000, -85,
 240,-1000,-1000,-1000,  56, -95, -95,-1000,-1000,-249,
-149, 299,-1000,-309,-1000, 135,-1000, 133,-1000,-1000,
-1000, -95,-1000, -95,  25, 129, 224,-249,-1000,-249,
-249,-249,  24,  22,-1000,-1000,-205,-1000,-1000,-1000,
-1000,-1000,-1000 };
short yypgo[]={

   0, 709, 590, 571, 708, 707, 706, 579, 547, 704,
 616, 703, 529, 527, 702, 701, 700, 518, 163, 699,
 698, 697,   7, 696, 695, 694, 546, 693, 691, 524,
 690,  26,   0, 687, 523, 551, 685, 683, 525, 681,
 522, 679, 678,   8, 677, 676, 675, 674, 174, 673,
 172, 672,  27,  23,   9,   1, 671,   3, 670, 669,
 668, 667, 666, 665, 664, 663, 661, 660, 659, 658,
 657, 656, 655, 654, 653,  24,  19,  36, 652,  17,
 651, 650, 649,  20,  21,   2,  18,  15, 521, 648,
  72,   4, 519,  14, 644,  13,  65, 190, 187, 295,
 637, 635, 634, 631, 415, 630, 411,  11, 625,  10,
   6, 622,   5, 621, 520, 620, 517, 614, 613, 516,
 601, 596, 515, 593, 584, 514, 583, 581, 574, 563,
 556, 548, 539, 531, 530,  16,  12 };
short yyr1[]={

   0,   1,   1,   1,   1,   1,   1,   6,   2,   9,
   2,  11,   3,  14,   3,  15,   4,  16,   5,  10,
  10,  12,  12,   7,   7,  19,  19,  20,  20,  20,
  20,  21,  13,   8,   8,  23,  23,  23,  23,  23,
  23,  23,  23,  23,  23,  23,  23,  25,  25,  30,
  29,  33,  29,  26,  26,  36,  34,  37,  34,  27,
  27,  39,  39,  38,  38,  38,  28,  28,  41,  41,
  40,  40,  42,  24,  43,  45,  45,  46,  46,  46,
  44,  44,  44,  44,  49,  49,  50,  48,  51,  51,
  51,  51,  52,  52,  52,  53,  53,  53,  22,  22,
  22,  55,  55,  56,  56,  54,  54,  57,  57,  57,
  57,  57,  57,  57,  57,  57,  57,  57,  57,  57,
  57,  57,  57,  57,  57,  58,  59,  60,  60,  76,
  76,  75,  78,  78,  79,  79,  61,  62,  63,  80,
  80,  64,  77,  77,  81,  81,  82,  65,  66,  67,
  68,  69,  69,  70,  71,  71,  84,  84,  83,  83,
  72,  72,  87,  87,  86,  86,  73,  74,  89,  89,
  90,  47,  47,  85,  85,  91,  91,  88,  88,  31,
  31,  31,  31,  31,  35,  94,  94,  95,  95,  95,
  95,  95,  95,  95,  95,  95,  93,  93,  96,  96,
  96,  96,  92,  92,  99, 100, 100, 101, 101,  97,
  97,  97,  98,  98,  98,  98, 105, 105, 106, 104,
 102, 102, 102, 102, 108, 108, 109, 109, 109, 107,
 107, 107, 103, 103, 103, 103, 111, 111, 112, 110,
  32, 113, 113, 114, 115, 115, 116, 116, 117, 118,
 118, 120, 120, 120, 120, 120, 120, 120, 119, 121,
 121, 123, 123, 123, 122, 124, 124, 126, 126, 126,
 126, 125, 125, 125, 127, 128, 128, 128, 128, 128,
 128, 128, 129, 129, 130, 130, 130, 130, 130, 130,
 130, 131, 131, 132, 132, 135, 135, 135, 133, 133,
 136, 136, 136, 134, 134,  17,  17,  18,  18 };
short yyr2[]={

   0,   1,   2,   1,   2,   1,   1,   0,   9,   0,
   9,   0,   8,   0,  10,   0,  11,   0,   9,   0,
   3,   0,   2,   0,   2,   5,   3,   1,   3,   3,
   5,   4,   5,   0,   2,   4,   2,   1,   2,   1,
   2,   1,   2,   1,   2,   1,   2,   1,   2,   0,
   7,   0,   5,   1,   2,   0,   5,   0,   5,   1,
   2,   1,   3,   4,   6,   4,   1,   2,   1,   3,
   2,   5,   0,   4,   5,   0,   2,   0,   4,   2,
   0,   1,   1,   2,   1,   2,   3,   3,   0,   1,
   1,   1,   3,   5,   3,   2,   4,   2,   0,   1,
   2,   0,   1,   1,   2,   1,   3,   1,   1,   1,
   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,
   1,   1,   1,   1,   1,   3,   1,   7,   6,   0,
   3,   3,   1,   3,   1,   3,   1,   2,  10,   0,
   2,   7,   0,   2,   0,   2,   4,   5,   3,   2,
   4,   1,   2,   5,   7,   6,   0,   3,   6,   3,
   7,   6,   0,   3,   3,   6,   5,   5,   1,   3,
   3,   0,   1,   1,   3,   1,   3,   1,   3,   1,
   2,   2,   1,   3,   1,   1,   1,   4,   2,   2,
   1,   4,   3,   3,   5,   1,   2,   1,   4,   3,
   3,   3,   1,   2,   6,   0,   2,   0,   2,   0,
   1,   2,   0,   1,   1,   2,   1,   2,   2,   2,
   0,   1,   1,   2,   1,   2,   3,   5,   4,   2,
   4,   3,   0,   1,   1,   2,   1,   2,   4,   3,
   1,   1,   3,   1,   1,   3,   2,   1,   1,   1,
   3,   1,   1,   1,   1,   1,   1,   1,   1,   1,
   3,   1,   1,   1,   1,   1,   3,   1,   1,   1,
   1,   1,   2,   2,   2,   1,   1,   1,   1,   1,
   3,   1,   0,   2,   2,   1,   3,   3,   2,   4,
   2,   1,   3,   1,   3,   1,   1,   3,   1,   3,
   1,   3,   3,   0,   2,   0,   1,   1,   3 };
short yychk[]={

-1000,  -1,  -2, 345,  -3,  -4,  -5, 318, 323, 314,
  -2,  -3, 286, 286, 318, 323,  -6,  -9, -11, -14,
 286, 286, 279, 266, -12, 310, -12, -15, -16,  -7,
 286, 279, -18, 286, 266, -10, 283, -10,  -8, -19,
 313, 316, -10,  -7, 263, 286, 279, -17, -18, 279,
 305, -23, -24, 300, 343, 337, 349, 308, 329, 286,
 -20, 286, 305, -13,  -8, 286, -10,  -7, 278,  -7,
 286, 266, 279, -25, -29, 286, -26, -34, -35, -91,
 286, -26, -27, -38, -39, 286, -28, -40, -41, 286,
 286, 316, 279, 263, 294, 286, 264, 295, 305,  -8,
 -13, 264, -13, -29, -30, -33, -34, -36, -37, 264,
 -38, 263, 262, 259, -40, 263, 279, 283, -42, -18,
 286, 286, 264, -22, -54, -57, -58, -21, -59, -60,
 -61, -62, -63, -64, -65, -66, -67, -68, -69, -70,
 -71, -72, -73, -74, -32,  -8, 299, 309, 306, 312,
 315, 319, 320, 330, 335, 336, 342, 344, 350, 351,
-113,-114,-115,-116, 324,-117,-118,-119,-121,-122,
-124,-125,-127, 274, 271,-128, 286, 287, 288, 289,
 290, 283, -96, 293, 333, 339, 286, 305, 264, 279,
 262, 266, 266, 281, 286, 286, -31, -35, -93, -94,
 283, 347, 338, -95, -96, 296, 329, -92, -97, 285,
 284, -99, 297, -32, 286, -31, -43, 283, 279, 294,
 305, 279, 259, 295, -32, -32, 286, -32, -32, -22,
 -32, -22, -32, -22, -32, -32, -89, -90, 286, 327,
 291,-116,-120, 266, 272, 269, 270, 267, 268, 317,
-123, 274, 271, 258,-126, 260, 280, 301, 322,-125,
-125,-129, -32, -88, 326, -31, -98,-104,-105, -18,
-106, 326, 264, 286, -31, -32, -31, -31, 279, 259,
 -92, -97, -92, -31, -92, -97, 338, -32, -43, -99,
 334, 325, -17, -32, 290, 279, 278, -44, -48, -49,
 -51, -50, 348, 349, 332, 286, 286, -57, -32, -22,
 326, 259, 340, 302, 305, 346, 311, 307, 326, 302,
 302, 263, 266,-114,-116,-119,-122,-125,-130, 264,
 282, 284, 283, 285, 278, 263, 326, -31, 305,-104,
-106, -52, -53, 262, 259, -31, 264, 266, 279, 279,
 279, -32, 278, 334, 312, -31, -98, 276, 265, 279,
 278, -48, -50, -18, 305, -75, -76, -78, -79, -32,
 -32, -22, -22, -32, -22, -83, -84, -85, -91, -86,
 -87, -88, -22, -22, -90, -32, 286,-131, -32,-132,
 278,-135, -32, -95, 286, -93,-133, 276,-136, -32,
 -31, -31, -31, -32, -32, 279, -31, -31,-100, 321,
 -32, -45, 262, -52, -53, -76, -77, 261, 303, 275,
 263, 265, 341, -81, 305, 305, -84, -77, 261, 283,
 275, 263, -87, -77, 261, 275, 283, 305, 305, 277,
 263, 278, 263, 259,-134, 263, 265, 259, 279, 259,
 279, 279,-101, 328,-102,-107,-108, 286,-109, 277,
 -46, 331, -31, -77, 305, -75, -22, -55, -56, -54,
 -79, -32, -32, -77, -82, 304, -77, 305, -83, 286,
 -55, -91, -77, 305, -86, -55, 286, -32,-135, -32,
 276,-136, 265, -32, -32, -32, 305,-103,-110,-111,
 286,-112,-107,-109, -43, 259, 285, 292, 305, 279,
 -80, 298, 305, -32, 305, 278, 305, 278, 279,-110,
-112, 259, 279, 259, -91, -47, -85, 302, -32, 340,
 275, 275, -91, -91, 279, 276, -22, -22, -55, -55,
 279, 279, 305 };
short yydef[]={

   0,  -2,   1,   0,   3,   5,   6,   0,   0,   0,
   2,   4,  -2,  -2,   0,   0,   0,   0,  21,  21,
  15,  17,  23,   0,   0,   0,   0,  19,  19,  33,
  19,  23,  22, 307,   0,   0, 305,   0,   0,  24,
   0,   0,   0,  33,   0,  19,  23,   0, 306,  23,
   0,  34,   0,  37,  39,  41,  43,  45,   0,   0,
   0,  27,   0,   0,   0, 308,   0,  33,  20,  33,
   0,  33,  36,  38,  47,  -2,  40,  53,  -2, 184,
 175,  42,  44,  59,   0,  61,  46,  66,   0,  68,
  72,   0,  26,   0,   0,   0,  12,  -2,   0,   0,
   0,   8,   0,  48,   0,   0,  54,   0,   0,   0,
  60,   0, 209,   0,  67,   0,  70, 209,   0,   0,
  29,  28,  10,   0,  99, 105, 107, 108, 109, 110,
 111, 112, 113, 114, 115, 116, 117, 118, 119, 120,
 121, 122, 123, 124, 126,   0,   0, 136,   0,   0,
   0,   0,  -2,   0,  -2, 151,  -2,   0,   0,   0,
 240, 241, 243, 244,   0, 247, 248, 249, 258, 259,
 264, 265, 271,   0,   0, 282, 275, 276, 277, 278,
 279,   0, 281, 209, 212,   0,   0,   0,  18,  35,
 209,   0, 209, 209, 176,  62,   0,  -2,  -2, 182,
 209, 209, 197, 185, 186,   0,   0,  -2,   0, 305,
   0, 202, 210,   0,  69,   0,  73,  -2,  25,   0,
   0,  -2,   0,  -2,   0, 137,   0,   0,   0,   0,
 149,   0, 152,   0,   0,   0,   0, 168,   0,   0,
   0, 246,   0, 251, 252, 253, 254, 255, 256, 257,
   0, 261, 262, 263,   0, 267, 268, 269, 270, 272,
 273, 274,   0,   0, 209, 177,   0, 213, 214,   0,
 216, 209,  14,   0,   0,   0,   0,   0,  63,   0,
  -2,   0,  -2,   0,  -2,   0, 196,   0, 188, 203,
 209, 212,   0,   0, 211,  65,   0,   0,  81,  -2,
   0,  84,  89,  90,  91,  30,  32, 106, 125,   0,
 129,   0,  -2,  -2, 148,   0,  -2, 156,  -2,  -2,
  -2,   0,   0, 242, 245, 250, 260, 266, 283,   0,
 285,   0, 209,   0, 280, 209, 209, 199, 200, 215,
 217, 218, 219, 209,   0, 201,  16,   0,  52,  56,
  58,   0, 183, 209, 209, 192, 205, 193,   0,  71,
  75,  83,  85,   0,  31, 129, 142,   0, 132, 134,
   0, 144,   0, 150,   0, 156, 142,   0, 173, 162,
 142,   0,   0,   0, 169, 170, 284,   0, 291,   0,
 288, 293, 295, 296, 275, 195, 303, 290, 298, 300,
 178, 198,  95,  97,   0,  64, 191, 187, 207, 220,
   0,  77, 209,  86,  87, 142,   0,   0,  -2,  -2,
   0,   0,   0, 142, 147, 153, 142,   0,   0,   0,
  -2,   0, 142,   0, 209,  -2,   0, 166, 167, 286,
   0, 287, 209,   0,   0,   0,   0,   0,  92,   0,
  94,  50,   0, 232, 206, 221, 222,   0, 224, 194,
  74,   0,  76,   0, 128, 130, 143, 131, 102, 103,
 133, 135, 139,   0, 145,   0,   0, 155, 157,   0,
 159, 174,   0, 161, 163, 164,   0, 292, 294, 297,
 289, 299, 304, 301, 302,  96, 204, 208, 233, 234,
   0, 236, 223, 225, 229,   0, 171,  79, 127,  -2,
   0,   0, 141,   0, 154,   0, 160,   0,  93, 235,
 237,   0, 226,   0, 231,   0, 172,  -2, 140,  -2,
  -2,  -2, 239, 230, 228,  78,   0, 146, 158, 165,
 238, 227, 138 };
#ifndef lint
static char yaccpar_sccsid[] = "@(#)yaccpar	4.1	(Berkeley)	2/11/83";
#endif

#
# define YYFLAG -1000
# define YYERROR goto yyerrlab
# define YYACCEPT return(0)
# define YYABORT return(1)

/*	parser for yacc output	*/

#ifdef YYDEBUG
int yydebug = 0; /* 1 for debugging */
#endif
YYSTYPE yyv[YYMAXDEPTH]; /* where the values are stored */
int yychar = -1; /* current input token number */
int yynerrs = 0;  /* number of errors */
short yyerrflag = 0;  /* error recovery flag */

yyparse() {

	short yys[YYMAXDEPTH];
	short yyj, yym;
	register YYSTYPE *yypvt;
	register short yystate, *yyps, yyn;
	register YYSTYPE *yypv;
	register short *yyxi;

	yystate = 0;
	yychar = -1;
	yynerrs = 0;
	yyerrflag = 0;
	yyps= &yys[-1];
	yypv= &yyv[-1];

 yystack:    /* put a state and value onto the stack */

#ifdef YYDEBUG
	if( yydebug  ) printf( "state %d, char 0%o\n", yystate, yychar );
#endif
		if( ++yyps> &yys[YYMAXDEPTH] ) { yyerror( "yacc stack overflow" ); return(1); }
		*yyps = yystate;
		++yypv;
		*yypv = yyval;

 yynewstate:

	yyn = yypact[yystate];

	if( yyn<= YYFLAG ) goto yydefault; /* simple state */

	if( yychar<0 ) if( (yychar=yylex())<0 ) yychar=0;
	if( (yyn += yychar)<0 || yyn >= YYLAST ) goto yydefault;

	if( yychk[ yyn=yyact[ yyn ] ] == yychar ){ /* valid shift */
		yychar = -1;
		yyval = yylval;
		yystate = yyn;
		if( yyerrflag > 0 ) --yyerrflag;
		goto yystack;
		}

 yydefault:
	/* default state action */

	if( (yyn=yydef[yystate]) == -2 ) {
		if( yychar<0 ) if( (yychar=yylex())<0 ) yychar = 0;
		/* look through exception table */

		for( yyxi=yyexca; (*yyxi!= (-1)) || (yyxi[1]!=yystate) ; yyxi += 2 ) ; /* VOID */

		while( *(yyxi+=2) >= 0 ){
			if( *yyxi == yychar ) break;
			}
		if( (yyn = yyxi[1]) < 0 ) return(0);   /* accept */
		}

	if( yyn == 0 ){ /* error */
		/* error ... attempt to resume parsing */

		switch( yyerrflag ){

		case 0:   /* brand new error */

			yyerror( "syntax error" );
		yyerrlab:
			++yynerrs;

		case 1:
		case 2: /* incompletely recovered error ... try again */

			yyerrflag = 3;

			/* find a state where "error" is a legal shift action */

			while ( yyps >= yys ) {
			   yyn = yypact[*yyps] + YYERRCODE;
			   if( yyn>= 0 && yyn < YYLAST && yychk[yyact[yyn]] == YYERRCODE ){
			      yystate = yyact[yyn];  /* simulate a shift of "error" */
			      goto yystack;
			      }
			   yyn = yypact[*yyps];

			   /* the current yyps has no shift onn "error", pop stack */

#ifdef YYDEBUG
			   if( yydebug ) printf( "error recovery pops state %d, uncovers %d\n", *yyps, yyps[-1] );
#endif
			   --yyps;
			   --yypv;
			   }

			/* there is no state on the stack with an error shift ... abort */

	yyabort:
			return(1);


		case 3:  /* no shift yet; clobber input char */

#ifdef YYDEBUG
			if( yydebug ) printf( "error recovery discards char %d\n", yychar );
#endif

			if( yychar == 0 ) goto yyabort; /* don't discard EOF, quit */
			yychar = -1;
			goto yynewstate;   /* try again in the same state */

			}

		}

	/* reduction by production yyn */

#ifdef YYDEBUG
		if( yydebug ) printf("reduce %d\n",yyn);
#endif
		yyps -= yyr2[yyn];
		yypvt = yypv;
		yypv -= yyr2[yyn];
		yyval = yypv[1];
		yym=yyn;
			/* consult goto table to find next state */
		yyn = yyr1[yyn];
		yyj = yypgo[yyn] + *yyps + 1;
		if( yyj>=YYLAST || yychk[ yystate = yyact[yyj] ] != -yyn ) yystate = yyact[yypgo[yyn]];
		switch(yym){
			
case 7:
# line 58 "../src/parse.yacc"
{recordname(lastident, 0); recordQual(lastident); } break;
case 9:
# line 63 "../src/parse.yacc"
{recordname(lastident, 0); recordQual(lastident); } break;
case 11:
# line 69 "../src/parse.yacc"
{recordname(lastident, 0); recordQual(lastident);} break;
case 13:
# line 71 "../src/parse.yacc"
{recordname(lastident, 0); recordQual(lastident);} break;
case 15:
# line 77 "../src/parse.yacc"
{recordname(lastident, 0); recordQual(lastident); } break;
case 17:
# line 85 "../src/parse.yacc"
{recordname(lastident, 0); recordQual(lastident);} break;
case 49:
# line 151 "../src/parse.yacc"
{if (!noconst) recordname(lastident, 1);} break;
case 51:
# line 153 "../src/parse.yacc"
{if (!noconst) recordname(lastident, 1);} break;
case 55:
# line 163 "../src/parse.yacc"
{if (!notypes) recordname(lastident, 1);} break;
case 57:
# line 165 "../src/parse.yacc"
{if (!notypes) recordname(lastident, 1);} break;
case 61:
# line 175 "../src/parse.yacc"
{if (!novars) recordname(lastident, 1);} break;
case 62:
# line 176 "../src/parse.yacc"
{if (!novars) recordname(lastident, 1);} break;
case 68:
# line 192 "../src/parse.yacc"
{if (!novars) recordname(lastident, 1);} break;
case 69:
# line 193 "../src/parse.yacc"
{if (!novars) recordname(lastident, 1);} break;
case 72:
# line 203 "../src/parse.yacc"
{recordname(lastident, 1);} break; 
		}
		goto yystack;  /* stack new state and value */

	}
