(* Copyright (C) 1992, Digital Equipment Corporation                         *)
(* All rights reserved.                                                      *)
(* See the file COPYRIGHT for a full description.                            *)
(*                                                                           *)
(* Last modified on Sun Jul  5 13:26:28 PDT 1992 by meehan *)
(*      modified on Tue Jun 16 13:07:58 PDT 1992 by muller *)
(*      modified on Sun Jun 14 08:47:33 1992 by mhb *)
<*PRAGMA LL*>

(* A "ZGrowVBT" is a switch that has the side effect of reshaing
   its nearest ancestor that's a non-background child of a
   "ZSplit".  If the initial mouse click is unshifted, the child
   is lifted to the top of its sibling; otherwise, the child
   keeps its current top-to-bottom ordering among its sibling.
   As the mouse is moved, the cursor changes to give appropriate
   feedback and an outline of the child is displayed to show the shape
   the child will acquire on an uncancelled upclick.  The shape
   of the child is not actually changed until an uncancelled upclick.
   The outline is removed on an uncancelled upclick or on a
   chord-cancel. *)

INTERFACE ZGrowVBT;

IMPORT Feedback, ZMoveVBT;

TYPE
  T <: Public;
  Public =
    ZMoveVBT.T OBJECT 
    METHODS 
      init (f: Feedback.T): T; 
    END;

END ZGrowVBT.









